/**
 * Created by wilsonshang on 16-7-20.
 */
/**
 * @description 日历组件基类
 * @constructor
 * @param {function} callback - 选择结束回调函数
 * */
UI.DatePanel = function (parameters,callback) {
    if(this.constructor.arguments.length == 2 ){
        this.parameters = this.constructor.arguments[0];
    }
    //this.title = title;
    this.callback = this.constructor.arguments[this.constructor.arguments.length-1];
    //this.closeCallback = closeCallback;
   // this.parameters = parameters ;

    UI.Panel.call(this);
    this.dom.className = "DatePanel";

    this.addClass("date-panel");
    this.dom.style.height = (window.innerHeight - 64)+'px'

    var header = new UI.Div();
    this.add(header);

    header.addClass("date-header");

    this.header = header;

    this.initTitle();

    var list = new UI.List();
    this.add(list);
    list.addClass("month-list");
    this.list = list;

//    if(this.parameters && this.parameters.date){
//        var today = new Date(this.parameters.date);
//    }else{
//        var today = new Date();
//    }
    var today = new Date();

    today.setHours(0, 0, 0, 0);

    var year = today.getFullYear();
    var month = today.getMonth();

    this.allMonths = {};
    this.keyIndices = [];

    var listHeight = 0;

    if(this.parameters && this.parameters.type && this.parameters.type == 'train'){
         this.showMounthNub = 2 ; //显示月份的数量
    }else{
        this.showMounthNub = 25 ;
    }

    for (var j = 0; j < this.showMounthNub; ++j) {

        var monthPanel ;
        if(this.parameters && this.parameters.days){
             monthPanel = new UI.MonthPanel(this, year, month, today.getTime(), this.parameters.days);
        }else{
             monthPanel = new UI.MonthPanel(this, year, month, today.getTime());
        }


        list.add(monthPanel);

        this.allMonths[year + "_" + month] = monthPanel;
        this.keyIndices.push(year + "_" + month);

        monthPanel.getHeight();

        if ( ++month >= 12 ) {

            ++ year;
            month = 0;

        }

    }

    return this;

};

UI.DatePanel.prototype = Object.create(UI.Panel.prototype);

Object.assign(UI.DatePanel.prototype, {

    constructor: UI.DatePanel,

    /**
     * @description 标题显示
     *
     * */
    initTitle: function() {

        //var div = new UI.Div();
        //this.header.add(div);
        //div.addClass("date-title");
        //
        //var cc = new UI.Div();
        //div.add(cc);
        //cc.setFloat("left");
        //
        //var btn = new UI.Div();
        //btn.addClass("x");
        //cc.add(btn);
        //
        //
        //var scope = this;
        //
        //cc.addEventListener(EVENT.CLICK, function (event) {
        //
        //    if (scope.closeCallback !== null && scope.closeCallback != undefined) {
        //
        //        scope.closeCallback();
        //
        //    }
        //
        //});

        //var title = new UI.Div();
        //div.add(title);
        //
        //title.setTextContent(this.title);
        //title.setCursor("default");
        //title.setTextAlign("center");

        var weekLabels = DateUtils.weekLabels;
        var len = weekLabels.length;

        for (var i = 0; i < len; ++i) {

            var txt = new UI.Text(weekLabels[i]);
            this.header.add(txt);
            txt.addClass("day-label");
            txt.setWidth(DateUtils.colWidthRatio + "%");

        }

    },

    /**
     * @description 根据日期定位
     * @param {Date} date - 日期
     *
     * */
    setScrollPosition: function (date) {

//        var key = date.getFullYear() + "_" + date.getMonth();
//
//        var mp;
//        var i = 0;
//
//        for (i = 0; i < this.keyIndices.length; ++i) {
//
//            if (key === this.keyIndices[i]) break;
//
//        }
//
//        var offsetHeight = 0;
//        for (var j = 0; j < i; ++j) {
//
//            key = this.keyIndices[j];
//            mp = this.allMonths[key];
//
//            offsetHeight += mp.getHeight();
//        }
//
//        this.dom.scrollTop(0, offsetHeight);
     if (this.seletedItem) {
                  var offsetHeight = this.seletedItem.dom.getBoundingClientRect().top - 100;
                  }
                  if (this.startItem) {
                  var offsetHeight = this.startItem.dom.getBoundingClientRect().top - 100;
                  }
        // $(".DatePanel")[0].scrollTo(0,offsetHeight)
        window.scrollTo(0,offsetHeight)

    },

    /**
     * @description 点击事件处理函数(子类需要重写处理逻辑)
     * @param {UI.DateItem} dateItem - 点击事件目标源
     * @return {boolean}
     * */
    tapHandler: function (dateItem) {

        console.log("tapHanlder() must be override by subClass");

        return false;

    },

    /**
     * @description 根据年,月获得月份组件
     * @param {int} year - 年
     * @param {int} month - 月
     * @return {UI.MonthPanel} - 月份组件
     * */
    getMonthPanel: function (year, month) {

        return this.allMonths[year + "_" + month];

    },

    clear: function () {



    }

});