/**
 * Created by wilsonshang on 16-7-21.
 */

/**
 * @author wilson
 * @description 酒店日期选择器中的tip
 * @contructor
 *
 * */
UI.HotelTip = function() {

    UI.Div.call(this);

    this.addClass("tip");

    var main = new UI.Div();
    this.add(main);
    main.addClass("tip-main")

    var titleTxt = new UI.Text("请选择离店日期");
    main.add(titleTxt);
    titleTxt.addClass("tip-title");

    this.titleTxt = titleTxt;

    var contentTxt = new UI.Text("7月22号入住");
    main.add(contentTxt);
    contentTxt.addClass("tip-content");

    var tri = new UI.Div();
    this.add(tri);
    tri.addClass("tip-tri");

    this.tri = tri;

    this.contextTxt = contentTxt;


};

UI.HotelTip.prototype = Object.create(UI.Div.prototype);

Object.assign(UI.HotelTip.prototype, {

    constructor: UI.HotelTip,

    /**
     * @description 设置标题显示
     *
     * */
    setTitle: function (value) {

        this.titleTxt.setValue(value);

    },

    /**
     * @description 设置内容显示
     *
     * */
    setContent: function (value) {

        this.contextTxt.setValue(value);

    },

    /**
     * @description 透明度
     * @param {boolean} [needAnimation] - 是否需要动画
     *
     * */
    setAlpha: function (alpha, needAnimation) {

        if (needAnimation) {

            this.addClass("tip-animation");

        } else {

            this.removeClass("tip-animation");

        }

        this.setOpacity(alpha * 100);

    },

    setShow: function (x, y) {

        var tw = this.getWidth();

        var off = 0;

        //宽度136.8px
        if (x < 5) {

            off = 60.4 - 5 + x;
            this.tri.setLeft(off + "px");
            x = 5;


        } else if (x + tw > window.screen.width - 5) {

            off = 60.4 + (x + tw) - (window.screen.width - 5);
            this.tri.setLeft(off + "px");
            x = window.screen.width - 5 - tw;
        } else {

            this.tri.setLeft("60.4px");
        }

        this.setX(x);
        this.setY(y);


    },

    /**
     * @description 横向定位
     * @param {number} x - 横向定位
     *
     * */
    setX: function (x) {

        this.setLeft(x + "px");

    },

    /**
     * @description 纵向定位
     * @param {number} y - 纵向定位
     *
     * */
    setY: function (y) {

        this.setTop(y + "px");

    }

});

