/**
 * Created by wilsonshang on 16-7-20.
 */

/**
 * @author wilson
 * @description 火车票日期选择面板
 * @contructor
 * @param {function} callback - 选择结束回调函数
 * */

UI.TrainTicketPanel = function (parameters,callback) {
    UI.DatePanel.call(this,parameters,callback);
    this.seletedItem = null;
    this.seletedDate = null;

};

UI.TrainTicketPanel.prototype = Object.create(UI.DatePanel.prototype);

Object.assign(UI.TrainTicketPanel.prototype, {

    constructor: UI.TrainTicketPanel,

    /**
     * @description 重写的标题函数
     *
     * */
    initTitle: function () {

        //var title = new UI.Text("选择入住离店日期");
        //
        //this.header.add(title);
        //
        //title.setDisplay("block");
        //title.setMarginTop("10px");
        //title.setMarginBottom("10px");

        UI.DatePanel.prototype.initTitle.call(this);

    },

    /**
     * @description 设置选择日期,同时改变显示状态
     * @param {Date} date - 选择日期
     * @return {UI.TrainTicketPanel} - 自身
     *
     * */
    setSelect: function (date) {

        this.seletedDate = date;
        this.updateSelect();

    },

    /**
     * @description 更新选择显示状态
     *
     * */
    updateSelect: function () {

        var year = this.seletedDate.getFullYear();
        var month = this.seletedDate.getMonth();

        var monthPanel = this.getMonthPanel(year, month);

        var dateItem = monthPanel.getDateItem(this.seletedDate);

        if (this.seletedItem !== null) {

            this.seletedItem.setStatus(DateUtils.DATE_ITEM_NORMAL);

        }

        this.seletedItem  = dateItem;
        dateItem.setStatus(DateUtils.DATE_ITEM_NODE);
        dateItem.setInfo("");

    },

    /**
     * @description 点击处理函数
     * @param {UI.DateItem} - 点击事件源
     * @return {boolean} - 处理成功
     * */
    tapHandler: function (dateItem) {

        this.setSelect(dateItem.getDate());

        if (this.callback != null) this.callback();

        return true;

    },

    /**
     * @description 清除函数
     * */
    clear: function () {

        if (this.seletedItem !== null) {

            this.seletedItem.setStatus(DateUtils.DATE_ITEM_NORMAL);

        }

        this.seletedItem = null;
        this.seletedDate = null;

    }


});